<?php

namespace Lc\CaracoleBundle\Container\Product;

use Lc\CaracoleBundle\Definition\Field\Product\ProductCategoryFieldDefinition;
use Lc\CaracoleBundle\Factory\Product\ProductCategoryFactory;
use Lc\CaracoleBundle\Repository\Product\ProductCategoryRepositoryQuery;
use Lc\CaracoleBundle\Repository\Product\ProductCategoryStore;
use Lc\CaracoleBundle\Solver\Product\ProductCategorySolver;

class ProductCategoryContainer
{
    protected ProductCategoryFactory $factory;
    protected ProductCategorySolver $solver;
    protected ProductCategoryRepositoryQuery $repositoryQuery;
    protected ProductCategoryStore $store;
    protected ProductCategoryFieldDefinition $fieldDefinition;

    public function __construct(
            ProductCategoryFactory $factory,
            ProductCategorySolver $solver,
            ProductCategoryRepositoryQuery $repositoryQuery,
            ProductCategoryStore $store,
            ProductCategoryFieldDefinition $fieldDefinition
    ) {
        $this->factory = $factory;
        $this->solver = $solver;
        $this->repositoryQuery = $repositoryQuery;
        $this->store = $store;
        $this->fieldDefinition = $fieldDefinition;
    }

    public function getFactory(): ProductCategoryFactory
    {
        return $this->factory;
    }

    public function getSolver(): ProductCategorySolver
    {
        return $this->solver;
    }

    public function getRepositoryQuery(): ProductCategoryRepositoryQuery
    {
        return $this->repositoryQuery;
    }

    public function getStore(): ProductCategoryStore
    {
        $this->store->resetContext();

        return $this->store;
    }

    public function getFieldDefinition(): ProductCategoryFieldDefinition
    {
        return $this->fieldDefinition;
    }

}