<?php

namespace Lc\CaracoleBundle\Repository\Reduction;

use Knp\Component\Pager\PaginatorInterface;
use Lc\CaracoleBundle\Repository\MerchantRepositoryQueryTrait;
use Lc\CaracoleBundle\Repository\SectionRepositoryQueryTrait;
use Lc\SovBundle\Repository\AbstractRepositoryQuery;

class ReductionCartRepositoryQuery extends AbstractRepositoryQuery
{
    use SectionRepositoryQueryTrait;

    public function __construct(ReductionCartRepository $repository, PaginatorInterface $paginator)
    {
        parent::__construct($repository, 'reductionCart', $paginator);
    }

    public function filterByCode(string $code)
    {
        return $this
                ->andWhere('.codes LIKE :code')
                ->setParameter('code', '%'.$code.'%') ;
    }
}
